HeaderTitle EQUS "\"MEMCPY\""

include "common/defines.inc"
include "common/header.inc"
include "common/functions.inc"

; Output:
;     1: copy block finished
;     2: verify block succeeded

SECTION "home", ROM0
ProgramStart:
	call clearLogo

	ld hl, $c000  ; WRAM
	ld bc, $0104  ; Cartridge Logo
	ld d, 48  ; size
	call memcpy

	ld hl, $8010
	call waitVBlank
	ld b, $ff
	call fillTile

	ld hl, $c000
	ld bc, $0104
	ld d, 48
.verifyLoop:
	ld a, [bc]
	cp [hl]
	jr nz, loop
	inc hl
	inc bc
	dec d
	jr nz, .verifyLoop

	ld hl, $8030
	call waitVBlank
	ld b, $ff
	call fillTile

loop:
	jr loop
